;J-BIRD STUB
.8086
JUMPS

DUMMY	SEGMENT	AT 0

	ORG	021H*4			; Int 21h
NEW21_INT	LABEL	DWORD
	
DUMMY	ENDS

CODE	SEGMENT

	ASSUME	CS:CODE 
	ORG	0H
	DB	055H			; GENERIC BIOS HEADER
	DB	0AAH
	DB	040h			; 64 * 512 = 32k

	NOP
	NOP
	NOP
	NOP

	CLD
	ASSUME	DS:DUMMY

	SUB	AX,AX
	MOV	DS,AX
	CLI
	MOV	AX,OFFSET INT21_INT	; Fake int21h
	MOV	WORD PTR NEW21_INT,AX
	MOV	WORD PTR NEW21_INT+2,CS

	STI 

	push cs
	pop ds

	mov ax,01000h
	mov es,ax
	mov si,0200h
	xor di,di

;function lz4_decompress(inb,outb:pointer):word

;Decompresses an LZ4 stream file with a compressed chunk 64K or less in size.
;Input:
;  DS:SI Location of source data.  DWORD magic header and DWORD chunk size
;        must be intact; it is best to load the entire LZ4 file into this
;        location before calling this code.
;
;Output:
;  ES:DI Decompressed data.  If using an entire 64K segment, decompression
;        is "safe" because overruns will wrap around the segment.
;  AX    Size of decompressed data.
;
;Trashes AX, BX, CX, DX, SI, DI
;        ...so preserve what you need before calling this code.


lz4_decompress:
        jmp     @decompinit
@SHR4table:
        DB 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
        DB 01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01
        DB 02,02,02,02,02,02,02,02,02,02,02,02,02,02,02,02
        DB 03,03,03,03,03,03,03,03,03,03,03,03,03,03,03,03
        DB 04,04,04,04,04,04,04,04,04,04,04,04,04,04,04,04
        DB 05,05,05,05,05,05,05,05,05,05,05,05,05,05,05,05
        DB 06,06,06,06,06,06,06,06,06,06,06,06,06,06,06,06
        DB 07,07,07,07,07,07,07,07,07,07,07,07,07,07,07,07
        DB 08,08,08,08,08,08,08,08,08,08,08,08,08,08,08,08
        DB 09,09,09,09,09,09,09,09,09,09,09,09,09,09,09,09
        DB 0Ah,0Ah,0Ah,0Ah,0Ah,0Ah,0Ah,0Ah,0Ah,0Ah,0Ah,0Ah,0Ah,0Ah,0Ah,0Ah
        DB 0Bh,0Bh,0Bh,0Bh,0Bh,0Bh,0Bh,0Bh,0Bh,0Bh,0Bh,0Bh,0Bh,0Bh,0Bh,0Bh
        DB 0Ch,0Ch,0Ch,0Ch,0Ch,0Ch,0Ch,0Ch,0Ch,0Ch,0Ch,0Ch,0Ch,0Ch,0Ch,0Ch
        DB 0Dh,0Dh,0Dh,0Dh,0Dh,0Dh,0Dh,0Dh,0Dh,0Dh,0Dh,0Dh,0Dh,0Dh,0Dh,0Dh
        DB 0Eh,0Eh,0Eh,0Eh,0Eh,0Eh,0Eh,0Eh,0Eh,0Eh,0Eh,0Eh,0Eh,0Eh,0Eh,0Eh
        DB 0Fh,0Fh,0Fh,0Fh,0Fh,0Fh,0Fh,0Fh,0Fh,0Fh,0Fh,0Fh,0Fh,0Fh,0Fh,0Fh

@decompinit:
        push    ds              ;preserve compiler assumptions
        push    bp              ;preserve compiler assumptions
        ;les     di,outb         ;load target buffer
        push    di              ;save original starting offset (in case != 0)
        ;lds     si,inb          ;load source buffer
        add     si,4            ;skip magic number
        cld                     ;make strings copy forward
        mov     bx,OFFSET @SHR4table ;prepare BX for XLAT later on
        lodsw                   ;load chunk size low 16-bit word
        mov     bp,ax           ;BP = size of compressed chunk
        lodsw                   ;load chunk size high 16-bit word
        add     bp,si           ;BP = threshold to stop decompression
        or      ax,ax           ;is high word non-zero?
        jnz     @done           ;If so, chunk too big or malformed, abort

@starttoken:
        lodsb                   ;grab token to AL
        mov     dx,ax           ;preserve packed token in DX
  segcs xlat                    ;unpack upper 4 bits, faster than SHR reg,cl
        mov     cx,ax           ;CX = unpacked literal length token
        jcxz    @copymatches    ;if CX = 0, no literals; try matches
        cmp     al,0Fh          ;is it 15?
        jne     @doliteralcopy1 ;if so, build full length, else start copying
@build1stcount:                 ;this first count build is not the same
        lodsb                   ;fall-through jump as the one in the main loop
        add     cx,ax           ;because it is more likely that the very first
        cmp     al,0FFh          ;length is 15 or more
        je      @build1stcount
@doliteralcopy1:
        rep     movsb           ;src and dst might overlap so do this by bytes

;At this point, we might be done; all LZ4 data ends with five literals and the
;offset token is ignored.  If we're at the end of our compressed chunk, stop.

        cmp     si,bp           ;are we at the end of our compressed chunk?
        jae     @done           ;if so, jump to exit; otherwise, process match

@copymatches:
        lodsw                   ;AX = match offset
        xchg    dx,ax           ;AX = packed token, DX = match offset
        and     al,0Fh          ;unpack match length token
        cmp     al,0Fh          ;is it 15?
        xchg    cx,ax           ;(doesn't affect flags); don't need ax any more
        je      @buildmcount    ;if not, start copying, otherwise build count

@domatchcopy:
        cmp     dx,2            ;if match offset=1 or 2, we're repeating a value
        jbe     @domatchfill    ;if so, perform RLE expansion optimally
        push    ds
        xchg    si,ax           ;ds:si saved
        mov     si,di
        sub     si,dx
        mov     dx,es
        mov     ds,dx           ;ds:si points at match; es:di points at dest
        movsw
        movsw                   ;minimum match is 4 bytes; move them ourselves
        shr     cx,1
        rep     movsw           ;cx contains count-4 so copy the rest
        adc     cx,cx
        rep     movsb
        xchg    si,ax
        pop     ds              ;ds:si restored

@parsetoken:                    ;CX always 0 here because of REP
        xchg    cx,ax           ;zero ah here to benefit other reg loads
        lodsb                   ;grab token to AL
        mov     dx,ax           ;preserve packed token in DX
@copyliterals:                  ;next 5 lines are 8088-optimal, do not rearrange
  segcs xlat                    ;unpack upper 4 bits, faster than SHR reg,cl
        mov     cx,ax           ;CX = unpacked literal length token
        jcxz    @copymatches    ;if CX = 0, no literals; try matches
        cmp     al,0Fh          ;is it 15?
        je      @buildlcount    ;if so, build full length, else start copying
@doliteralcopy:                 ;src and dst might overlap so do this by bytes
        rep     movsb           ;if cx=0 nothing happens

;At this point, we might be done; all LZ4 data ends with five literals and the
;offset token is ignored.  If we're at the end of our compressed chunk, stop.

@testformore:
        cmp     si,bp           ;are we at the end of our compressed chunk?
        jb      @copymatches    ;if not, keep going
        jmp     @done           ;if so, end

@domatchfill:
        je      @domatchfill2   ;if DX=2, RLE by word, else by byte
@domatchfill1:
        mov     al,es:[di-1]    ;load byte we are filling with
        mov     ah,al           ;copy to ah so we can do 16-bit fills
        stosw                   ;minimum match is 4 bytes, so we fill four
        stosw
        inc     cx              ;round up for the shift
        shr     cx,1            ;CX = remaining (count+1)/2
        rep     stosw           ;includes odd byte - ok because LZ4 never ends with matches
        adc     di,-1           ;Adjust dest unless original count was even
        jmp     @parsetoken     ;continue decompressing

@domatchfill2:
        mov     ax,es:[di-2]    ;load word we are filling with
        stosw                   ;minimum match is 4 bytes, so we fill four
        stosw
        inc     cx              ;round up for the shift
        shr     cx,1            ;CX = remaining (count+1)/2
        rep     stosw           ;includes odd byte - ok because LZ4 never ends with matches
        adc     di,-1           ;Adjust dest unless original count was even
        jmp     @parsetoken     ;continue decompressing

@buildlcount:                   ;build full literal length count
        lodsb                   ;get next literal count byte
        add     cx,ax           ;increase count
        cmp     al,0FFh          ;more count bytes to read?
        je      @buildlcount
        jmp     @doliteralcopy

@buildmcount:                   ;build full match length count - AX is 0
        lodsb                   ;get next literal count byte
        add     cx,ax           ;increase count
        cmp     al,0FFh          ;more count bytes to read?
        je      @buildmcount
        jmp     @domatchcopy

@done:
        pop     ax              ;retrieve previous starting offset
        sub     di,ax           ;subtract prev offset from where we are now
        xchg    ax,di           ;AX = decompressed size
        pop     bp              ;restore compiler assumptions
        pop     ds              ;restore compiler assumptions

; call far 1000:6
db 09ah
dw 6,01000h

INT21_INT	PROC	NEAR
	IRET
INT21_INT	ENDP


Free    EQU (200h) - ($-code)
if Free LT 0
	.ERR
	 %out FATAL PROBLEM: code too large
endif
	   db Free DUP(0ffh)

CODE ENDS

END